#include <bits/stdc++.h>
using namespace std;

int n,kga,kgb,kg0,kgab;
struct slog{
   string krvna_grupa;
   int broj_jedinica;
   int bra=0,brb=0,br0=0,brab=0;
};

    slog pacijent[10005];

int main(){

     cin>>n;
     cin>>kg0>>kga>>kgb>>kgab;
     for(int i=1;i<=n;i++){
       cin>>pacijent[i].krvna_grupa;
       cin>>pacijent[i].broj_jedinica;
     }

     for(int i=1;i<=n;i++){
       if(pacijent[i].krvna_grupa=="O" and pacijent[i].broj_jedinica<=kg0){
          kg0 -= pacijent[i].broj_jedinica;
          pacijent[i].br0 += pacijent[i].broj_jedinica; 
       }
       else if(pacijent[i].krvna_grupa=="O" and pacijent[i].broj_jedinica>kg0){
         cout<<"nemoguce"<<endl;
         return 0;
       }
     }   

     for(int i=1;i<=n;i++){
       if(pacijent[i].krvna_grupa=="A" and pacijent[i].broj_jedinica<=kga){
          kga -= pacijent[i].broj_jedinica;
          pacijent[i].bra += pacijent[i].broj_jedinica;
       }
       else  if(pacijent[i].krvna_grupa=="A" and pacijent[i].broj_jedinica>kga){
         pacijent[i].bra += kga;
         kg0 -= abs(kga-pacijent[i].broj_jedinica);
         pacijent[i].br0 += abs(kga-pacijent[i].broj_jedinica);
         kga=0;
       }
       
       if(kg0<0){
         cout<<"nemoguce"<<endl;
         return 0;
       }
       
     }

     for(int i=1;i<=n;i++){
       if(pacijent[i].krvna_grupa=="B" and (kgb-pacijent[i].broj_jedinica)>=0){
          kgb -= pacijent[i].broj_jedinica;
          pacijent[i].brb += pacijent[i].broj_jedinica;
       }
       else if(pacijent[i].krvna_grupa=="B" and (kgb-pacijent[i].broj_jedinica)<0){
         pacijent[i].brb += kgb;
         kg0 -= abs(kgb-pacijent[i].broj_jedinica);
         pacijent[i].br0 += abs(kgb-pacijent[i].broj_jedinica);
         kgb=0;
       }
       if(kg0<0){
         cout<<"nemoguce"<<endl;
         return 0;
       }
      
     }
     
   cout<<"moguce"<<endl;
     for(int i=1;i<=n;i++){
    
       cout<<pacijent[i].br0<<" "<<pacijent[i].bra<<" "<<pacijent[i].brb<<" "<<pacijent[i].brab<<endl;
     }
     
   return 0;
}